unit UDefaultRegistration;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Menus, UProt4Delphi, ClipBrd;

type
  TRegistrationForm = class(TForm)
    Panel1: TPanel;
    Label6: TLabel;
    Panel3: TPanel;
    Label5: TLabel;
    EditRegKey: TEdit;
    PopupMenu1: TPopupMenu;
    Copiaralclipboard1: TMenuItem;
    EERC: TEdit;
    SpeedButton1: TSpeedButton;
    procedure Copytoclipboard1Click(Sender: TObject);
    procedure EditRegKeyKeyPress(Sender: TObject; var Key: Char);
    procedure Copiaralclipboard1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    FProt4Delphi: TProt4Delphi;
  public
    { Public declarations }
    function ShowModal(Prot4Delphi: TProt4Delphi): Integer; reintroduce;
    class procedure CheckAndShowIfNotReg(Prot4Delphi: TProt4Delphi);
  end;

var
  RegistrationForm: TRegistrationForm;

implementation

{$R *.DFM}
uses UProt4DelphiDefs;


class procedure TRegistrationForm.CheckAndShowIfNotReg(Prot4Delphi: TProt4Delphi);
var
  RegFrm            : TRegistrationForm;
begin
  RegFrm := TRegistrationForm.Create(Application);
  try
    Prot4Delphi.Start;
    if not Prot4Delphi.IsRegistered then
    begin
      RegFrm.ShowModal(Prot4Delphi);
      if not Prot4Delphi.IsRegistered then
        ExitProcess(0);
    end;
  finally
    RegFrm.Free;
  end;
end;

function TRegistrationForm.ShowModal(Prot4Delphi: TProt4Delphi): Integer;
begin
  FProt4Delphi := Prot4Delphi;
  if Assigned(FProt4Delphi) then
  begin
    Caption := 'Registration form.' + '  ' + FProt4Delphi.MessageNotRegistered;
//    LblMsg.Caption := Caption;
//    LblMsg.Left := (Width - LblMsg.Width) div 2; // center
    EERC.Text := FProt4Delphi.RegistrationCode;
    if Trim(EERC.Text) = '' then
    begin
      ShowMessage('Error getting registration code, exiting');
      ExitProcess(0);
    end;
    result := inherited ShowModal;
  end
  else
    result := mrAbort;
end;



procedure TRegistrationForm.Copytoclipboard1Click(Sender: TObject);
var
  s                 : string;
begin
  s := EERC.Text;
  Clipboard.SetTextBuf(Pchar(s));
end;

procedure TRegistrationForm.EditRegKeyKeyPress(Sender: TObject;
  var Key: Char);
begin
  // Allow backspace, Ctrl V, Ctrl X, Ctrl C
  if (Key = #8) or (Key = #22) or (Key = #24) or (Key = #2) then
    Exit;
  Key := ValidateCodeRegKey(Key);
  if Ord(Key) = 0 then
    Windows.Beep(2000, 50);
end;

procedure TRegistrationForm.Copiaralclipboard1Click(Sender: TObject);
var
  RegCode           : string;
  MyClip, OldClip   : TClipboard;
begin
  try
    RegCode := FProt4Delphi.RegistrationCode;
    MyClip := TClipboard.Create;
    try
      OldClip := Clipboard;
      SetClipboard(MyClip);
      MyClip.Clear;
      MyClip.AsText := RegCode;
      SetClipboard(OldClip);
    finally
      MyClip.Free;
    end;
  except
  end;
end;



procedure TRegistrationForm.FormCreate(Sender: TObject);
begin
  ActiveControl := EditRegKey;
end;

procedure TRegistrationForm.SpeedButton1Click(Sender: TObject);
begin
  FProt4Delphi.SetRegistrationKey(EditRegKey.Text);
  if FProt4Delphi.IsRegistered then
  begin
    Caption := 'Registration form.' + '  ' + FProt4Delphi.MessageRegistered;
    Sleep(1000);
    Close;
  end
  else
    ShowMessage('Invalid Registration Key.');
end;

end.

